package example.codes;

import java.io.File;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import com.silanis.esl.sdk.*;
import com.silanis.esl.sdk.builder.*;
import com.silanis.esl.sdk.io.Files;

public class downloadDocumentDateRange {
	
	private static final String api_key = "api_key";
	private static final String api_url = "https://sandbox.esignlive.com/api";

	public static void main(String[] args) throws InterruptedException {
		
		EslClient client = new EslClient(api_key, api_url);
		
		int index = 1;
		
		Calendar cal = new GregorianCalendar();
		cal.add(Calendar.DAY_OF_MONTH, -7);
		Date from = cal.getTime();
		Date to = new Date();
		
		Page<DocumentPackage> completed_packages = client.getPackageService().getUpdatedPackagesWithinDateRange(PackageStatus.COMPLETED, new PageRequest(index, 50), from, to);
		
		while (index <= completed_packages.getNumberOfElements())
        {
            for (DocumentPackage pack : completed_packages)
            {
            	System.out.println("Downloading package: " + pack.getId() + "...");
                byte[] zipContent = client.downloadZippedDocuments(pack.getId());
                Files.saveTo(zipContent, "package-documents-"+ pack.getId().toString() +".zip");
                index++;
                Thread.sleep(1000);
            }
            completed_packages = client.getPackageService().getUpdatedPackagesWithinDateRange(PackageStatus.COMPLETED, new PageRequest(index, 50), from, to);
        }

	}

}
